// 002 u_40_excel_chart
// 03 dec 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_40_excel_chart;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Grids, DBGrids, DB, DBTables, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    create_application_: TButton;
    toggle_excel_visible_: TButton;
    Panel4: TPanel;
    Panel5: TPanel;
    close_excel_: TButton;
    CBChart: TComboBox;
    chart_: TButton;
    create_1_worksheet_: TButton;
    generate_data_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure create_application_Click(Sender: TObject);
    procedure toggle_excel_visible_Click(Sender: TObject);
    procedure close_excel_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure analyze_Click(Sender: TObject);
    procedure create_1_worksheet_Click(Sender: TObject);
    procedure chart_Click(Sender: TObject);
    procedure generate_data_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses ComObj, Variants
      , Excel97

      , u_types_constants, u_c_log, u_c_display
      , u_file, u_dir
      , u_strings
      , u_handle_files_in_dirs
      ;


    {$R *.DFM}

    const k_initial_directory= 'C:\programs\fr\com\excel\_data';

          k_extension= '.xls';
          k_file_name= 'annuaire.xls';

          k_my_sheet= 'my_sheet';
          k_save_file_name= 'my_sheet.xls';

    var g_path: String= k_initial_directory;
        g_file_name: String= k_file_name;

    var g_c_ole_application: variant;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ole_application:= Unassigned;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
      end;

    // -- actions

    procedure TForm1.create_application_Click(Sender: TObject);
        // -- create an OLE link for the Excel class
        // --   stored in the Registry
      begin
        g_c_ole_application:= CreateOleObject('Excel.Application');
      end; // create_application_Click

    procedure TForm1.toggle_excel_visible_Click(Sender: TObject);
        // -- togle the visibility of Excel
      begin
        g_c_ole_application.visible:= Not g_c_ole_application.visible;
      end; // excel_visible_Click

    procedure TForm1.create_1_worksheet_Click(Sender: TObject);
      var l_c_worksheet: Variant;
      begin
        l_c_worksheet:= g_c_ole_application.Workbooks.Add(xlWBATWorksheet);
        g_c_ole_application.Workbooks[1].WorkSheets[1].Name:= k_my_sheet;
      end; // create_1_worksheet_Click

    procedure TForm1.analyze_Click(Sender: TObject);
      var l_c_ole_worksheet: Variant;
          l_workbook_index: Integer;
          l_sheet_index: Integer;
      begin
        display('> analyze_Click');
        for l_workbook_index:= 1 to g_c_ole_application.Workbooks.Count do
        begin
          display('Workbook: ' + g_c_ole_application.Workbooks[l_workbook_index].Name);
          for l_sheet_index:= 1 to g_c_ole_application.Workbooks[l_workbook_index].Sheets.Count do
          begin
            l_c_ole_worksheet:= g_c_ole_application.Workbooks[l_workbook_index].Sheets[l_sheet_index];
            display('  Sheet: ' + l_c_ole_worksheet.Name);
          end;
        end;
        display('< analyze');
      end; // analyze_Click

    procedure TForm1.close_excel_Click(Sender: TObject);
      begin
        g_c_ole_application.Quit;
        g_c_ole_application:= Unassigned;
      end; // close_excel_Click

    const k_data_sheet_name= 'my_data';
          k_chart_sheet_name= 'my_chart';

    procedure TForm1.generate_data_Click(Sender: TObject);
      var l_c_ole_sheets: Variant;
          l_c_ole_data_worksheet: Variant;
          l_row: Integer;
      begin
        l_c_ole_sheets:= g_c_ole_application.Workbooks[1].Sheets;

        l_c_ole_data_worksheet:= g_c_ole_application.Workbooks[1].Sheets[1];
        l_c_ole_data_worksheet.Name:= k_data_sheet_name;

        // -- create data for the graph in the data sheet
        for l_row:= 1 to 15 do
          l_c_ole_data_worksheet.Cells[l_row, 1]:= 100+ Random(100);
        for l_row:= 1 to 15 do
          l_c_ole_data_worksheet.Cells[l_row, 2]:= 80 + Random(6);
        for l_row:= 1 to 15 do
          l_c_ole_data_worksheet.Cells[l_row, 3]:= 90+ Random(12);
        for l_row:= 1 to 15 do
          l_c_ole_data_worksheet.Cells[l_row, 4]:= 50+ Random(4);
      end; // generate_data_Click

    procedure TForm1.chart_Click(Sender: TObject);
      var l_c_ole_sheets: Variant;
          l_c_ole_range: Variant;
          l_c_ole_chart_worksheet: Variant;
          l_c_ole_data_worksheet: Variant;
      begin
        l_c_ole_sheets:= g_c_ole_application.Workbooks[1].Sheets;

        // -- To build the graph
        l_c_ole_range:= l_c_ole_sheets.Item[k_data_sheet_name].Range['A1:D15'];

        // -- Active Sheet
        l_c_ole_chart_worksheet:= g_c_ole_application.Workbooks[1].Sheets.Add(, , 1, xlChart);
        l_c_ole_chart_worksheet.Name:= k_chart_sheet_name;

        l_c_ole_sheets.Item[k_chart_sheet_name].ChartType:= xl3DAreaStacked;
        // l_c_ole_sheets.Item[k_chart_sheet_name].ChartType:= xl3DColumnStacked;
        // l_c_ole_sheets.Item[k_chart_sheet_name].ChartType:= xlLineMarkers;

        l_c_ole_sheets.Item[k_chart_sheet_name].SeriesCollection.Add(l_c_ole_range);
        // l_c_ole_sheets.Item[k_chart_sheet_name].SeriesCollection.Item[1].HasDataLabels:= True;
        // l_c_ole_sheets.Item[l_chart_sheet_name].ChartType:= xlColumnClustered ;


        { Charttypes
        xlColumnClustered, xlColumnStacked, xlColumnStacked100, xl3DColumnClustered
        xl3DColumnStacked, xl3DColumnStacked100, xlBarClustered, xlBarStacked
        xlBarStacked100, xl3DBarClustered, xl3DBarStacked, xl3DBarStacked100
        xlLineStacked, xlLineStacked100, xlLineMarkers, xlLineMarkersStacked
        xlLineMarkersStacked100, xlPieOfPie, xlPieExploded, xl3DPieExploded, xlBarOfPie
        xlXYScatterSmooth, xlXYScatterSmoothNoMarkers, xlXYScatterLines, xlXYScatterLinesNoMarkers
        xlAreaStacked, xlAreaStacked100, xl3DAreaStacked, xl3DAreaStacked100, xlDoughnutExploded
        xlRadarMarkers, xlRadarFilled, xlSurface, xlSurfaceWireframe, xlSurfaceTopView
        xlSurfaceTopViewWireframe, xlBubble, xlBubble3DEffect, xlStockHLC, xlStockOHLC
        xlStockVHLC, xlStockVOHLC, xlCylinderColClustered, xlCylinderColStacked
        xlCylinderColStacked100, xlCylinderBarClustered, xlCylinderBarStacked
        xlCylinderBarStacked100, xlCylinderCol, xlConeColClustered, xlConeColStacked
        xlConeColStacked100, xlConeBarClustered, xlConeBarStacked, xlConeBarStacked100
        xlConeCol, xlPyramidColClustered, xlPyramidColStacked, xlPyramidColStacked100
        xlPyramidBarClustered, xlPyramidBarStacked, xlPyramidBarStacked100, xlPyramidCol
        xl3DColumn, xlLine, xl3DLine, xl3DPie, xlPie, xlXYScatter, xl3DArea, xlArea
        xlDoughnut, xlRadar}
      end;

end.

